from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, Boolean, Directory, String

Fastq_Dl_V0_1_0 = CommandToolBuilder(tool="fastq_dl", base_command=["fastq-dl"], inputs=[ToolInput(tag="in_aspera", input_type=File(optional=True), prefix="--aspera", doc=InputDocumentation(doc="Path to the Aspera Connect tool 'ascp' (Default:\n'which ascp')")), ToolInput(tag="in_aspera_key", input_type=File(optional=True), prefix="--aspera_key", doc=InputDocumentation(doc="Path to Aspera Connect private key, if not given,\nguess based on ascp path")), ToolInput(tag="in_aspera_speed", input_type=Int(optional=True), prefix="--aspera_speed", doc=InputDocumentation(doc="Speed at which Aspera Connect will download. (Default:\n100M)")), ToolInput(tag="in_is_study", input_type=Boolean(optional=True), prefix="--is_study", doc=InputDocumentation(doc="Query is a Study.")), ToolInput(tag="in_is_experiment", input_type=Boolean(optional=True), prefix="--is_experiment", doc=InputDocumentation(doc="Query is an Experiment.")), ToolInput(tag="in_is_run", input_type=Boolean(optional=True), prefix="--is_run", doc=InputDocumentation(doc="Query is a Run.")), ToolInput(tag="in_group_by_experiment", input_type=Boolean(optional=True), prefix="--group_by_experiment", doc=InputDocumentation(doc="Group Runs by experiment accession.")), ToolInput(tag="in_group_by_sample", input_type=Boolean(optional=True), prefix="--group_by_sample", doc=InputDocumentation(doc="Group Runs by sample accession.")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="Directory to output downloads to. (Default: ./)")), ToolInput(tag="in_prefix", input_type=String(optional=True), prefix="--prefix", doc=InputDocumentation(doc="Prefix to use for naming log files (Default: fastq)")), ToolInput(tag="in_max_attempts", input_type=Int(optional=True), prefix="--max_attempts", doc=InputDocumentation(doc="Maximum number of download attempts (Default: 10)")), ToolInput(tag="in_cpus", input_type=Int(optional=True), prefix="--cpus", doc=InputDocumentation(doc="Total cpus used for downloading from SRA (Default: 1)")), ToolInput(tag="in_ftp_only", input_type=Boolean(optional=True), prefix="--ftp_only", doc=InputDocumentation(doc="FTP only downloads.")), ToolInput(tag="in_sra_only", input_type=Boolean(optional=True), prefix="--sra_only", doc=InputDocumentation(doc="Do not attempt to fall back on ENA if SRA download\ndoes not work (e.g. missing FASTQ).")), ToolInput(tag="in_silent", input_type=Boolean(optional=True), prefix="--silent", doc=InputDocumentation(doc="Only critical errors will be printed.")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Print debug related text.")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="Skip downloads, print what will be downloaded.")), ToolInput(tag="in_accession", input_type=String(), position=0, doc=InputDocumentation(doc="ENA/SRA accession to query. (Study, Experiment, or Run\naccession)"))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="Directory to output downloads to. (Default: ./)"))], container="quay.io/biocontainers/fastq-dl:1.0.6--0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Fastq_Dl_V0_1_0().translate("wdl")

